#!/usr/bin/python

# license: wtfpl
# http://www.wtfpl.net/txt/copying/

# AD210 arbeitet nicht mit ASCII-Zeichen , sondern "rohen" Bytes (8 bit)
# 1-byte-Befehle, ein oder zwei Bytes (bytehi, bytelow) als Antwort
# "1" fragt Kennung des AD210 ab
# "58" liest ADC2 (PinB4) aus 
# "59" liest ADC2 (PinB4) aus
# "64" + 0 ... 255 setzt PWM-Ausgang (PinB0)

# raw_input 

# Bedienung:
# raw_input muss immer mit <return> abgeschlossen werden
# q <return> : Ende 
# Zahl 0 ... 255 <return> : PWM-output setzen


import serial, sys, time, thread


def input_thread():
    global kbd
    kbd = ''
    while (1):
        kbd =raw_input()



# Hauptprogramm

try:
    ser = serial.Serial("/dev/ttyUSB1",38400,timeout=2)   # unter Windows: "com1" bis "com255"
    time.sleep (0.5)                                      # Warten auf DTR (versorgt AD210 mit Spannung)
    ser.flushInput()
except:
    print "-----> serielle Schnittstelle nicht vorhanden" 
    quit()

ser.write(chr(1))                            # sendet raw 1
time.sleep (0.01)
if (ser.inWaiting() == 0):
    print "-----> AD210 antwortet nicht!"
    quit()
   
x = ord(ser.read())           # 1-byte string, umgewandelt in raw (integer)

if (x == 100):                # "Lebenszeichen" des AD210
    print "-----> AD210 connected!"
else:
    print "-----> No connect"
    quit()


thread.start_new_thread(input_thread, ())   # input-thread starten


while 1:

    ser.write(chr(58))                       # ersten ADC abfragen
    x1 = ser.read()                      # hi_byte
    x2 = ser.read()                      # low_byte
    # die 1-byte-strings werden erst in ints umgewandelt, dann addiert,
    # dann wieder in string gewandelt
    s1 = str(256 * ord(x1) + ord(x2))

    ser.write(chr(59))              # zweiten ADC abfragen, bessere Variante
    y1 = ser.read()
    y2 = ser.read()
    s2 = str(256 * ord(y1) + ord(y2))
    print "ch1 =", s1 , "   ch2 = ", s2   # ausgeben

    time.sleep(0.5)                       # kann bis auf 0 reduziert werden 



    if (kbd != ""):
        if (kbd =="q"):
            quit()

        try:
            pwm = int (kbd)
            if (pwm > 255) or (pwm < 0):
                print "-----> Zahl zwischen 0 und 255!"
            else:
                ser.write (chr(64))       # pwm-Wert ankuendigen
                ser.write (chr(pwm))
        except:
            print "-----> Zahl eingeben"
        kbd = ""                          # alten Wert loeschen
