#!/usr/bin/python

# license: wtfpl
# http://www.wtfpl.net/txt/copying/

import thread
import time
import serial
from Tkinter import *
import tkMessageBox
file_is_open = 0


#----- thread, der unabhaengig von dem GUI laeuft: ------

def get_values():

    port, ser = choose_serial()
    text8 = port
    time_old = time.time()
    scale_old=0
    pwm = "0.00"
    text2.delete(1.0 , 2.0)
    text2.insert(INSERT, pwm+"V")

    while (1):


##      Schieberegler abfragen, PWM erzeugen

        scale_new = scale.get()           # scale_get liefert integer
        if (scale_new != scale_old):      # nur senden, wenn Wert geaendert wurde
            ser.write(chr(64) + chr(scale_new))
            time.sleep(0.001)
            scale_old = scale_new
            scale_f = "{0:2.2f}".format(scale_new *0.01295)
            pwm = str(scale_f)
            text2.delete(1.0 , 2.0)
            text2.insert(INSERT, pwm+"V")

##      ersten ADC abfragen

        reference1 = ref1.get()
        if (reference1 == "lo"):
            ser.write(chr(56))
        else: 
            ser.write(chr(58))
        x11 = ser.read()
        x12 = ser.read()
        # die beiden 1-byte-strings werden erst in ints umgewandelt,
        # dann addiert, danach wieder in einen string gewandelt:
        res11 = 256 * ord(x11) + ord(x12)
        if(reference1 == "lo"):
            res12 = res11 * 0.01        # Umrechnung ADC-Werte in Volt 
        else:
            res12 = res11 * 0.03
        res12_f = "{0:2.2f}".format(res12)  # auf 2 Nachkommastellen formatieren
        res13 = str(res12_f)
        lb_adc1.delete(1.0 , 2.0)
        lb_adc1.insert(INSERT,res13+"V")

##      zweiten ADC abfragen
        reference2 = "lo"
        reference2 = ref2.get()
        if (reference2 == "lo"):
            ser.write(chr(57))
        else: 
            ser.write(chr(59))
        x21 = ser.read()
        x22 = ser.read()
        res21 = 256 * ord(x21) + ord(x22)
        if (reference2 == "lo"):
            res22 = res21 * 0.01
        else:
            res22 = res21 * 0.03
        res22_f = "{0:2.2f}".format(res22)
        res23 = str(res22_f)
        lb_adc2.delete(1.0 , 2.0)
        lb_adc2.insert(INSERT,res23 + "V")


##      ins File schreiben:
        if (file_is_open == 1):
            interval = get_interval()
            time_new = time.time()
            if ((time_new - time_old) >= interval):
                time_old = time_new
                try:
                    ltime = time.localtime() 
                    h, m , s = ltime[3:6]
                    time_string = "{0:02d}:{1:02d}:{2:02d}".format(h,m,s)
                    logfile.write (time_string + chr(9) + res13 + chr(9) +res23 + "\r")
                except:
                     print "writing failed"

#---- Ende thread -----



def get_interval():

    get_interval = entry5.get() 
    try:
        interval= float(get_interval)
    except:
        interval = 1
    return interval


def start_log():

    global logfile
    global file_is_open

    filename = "ad210.csv"
    getfilename= entry6.get()
    if getfilename != "":
        filename = getfilename
    logfile = open (filename,"a+")   # +a: append to file
    file_is_open = 1
    print "filename=", filename 



def stop_log():
    global file_is_open
    try:
        logfile.close()
        file_is_open = 0
    except:
        pass



#----- AD210 suchen -----

def choose_serial():

    speed = "38400"
    ad210port =""
    portnames = scan_serial()
    print "found", portnames
    for port in portnames:

        try:
            ser = serial.Serial(port,speed,timeout=2)
            ser.setDTR()            # DTR = Stromversorgung fuer AD210
            ser.setRTS()            # dito
            time.sleep(0.2)         # Wartezeit auf Stromversorgung (> 0.1s)      
            ser.flushInput()
            ser.flushOutput()
            ser.write(chr(1))
            time.sleep(0.02)
            if (ser.inWaiting() != 0):
                x = ord(ser.read())  # 1-byte string wird in int umgewandelt
            if (x == 100):           # 100: Lebenszeichen des AD210
                print "ad210 connected to" , port
                text8["text"] = "Port: " + port
                ad210port = port
                break
#            ser.close()
        except:
            pass
    if len(ad210port) == 0:
        print "no ad210 found"
        tkMessageBox.showerror("Error", "kein AD210 gefunden!")

    return ad210port, ser


#----- vorhandene serielle Schnittstellen suchen -----

def scan_serial():

    portnames = []

    # Windows
    for i in range(127):
        try:
            name = "COM"+str(i)
            s = serial.Serial(name  )
            s.close()
            portnames.append (name)
        except:
            pass

    # Linux (feste Schnittstellen)
    for i in range(8):
        try:
            name = "/dev/ttyS"+str(i)
            s = serial.Serial(name  )
            s.close()
            portnames.append (name)
        except:
            pass

    # Linux (USB serial)
    for i in range(8):
        try:
            name = "/dev/ttyUSB"+str(i)
            s = serial.Serial(name  )
            s.close()
            portnames.append (name)
        except:
            pass

    # Linux (HID serial)
    for i in range(8):
        try:
            name = "/dev/ttyACM"+str(i)
            s = serial.Serial(name  )
            s.close()
            portnames.append (name)
        except:
            pass
    if len(portnames) == 0:
        print "no serial found"
        tkMessageBox.showerror("Error", "Keine serielle Schnittstelle gefunden!")
        quit()
    return portnames



#----- Programm beenden ------

def ende():
    print("Ende !")
    try:
        ser.write(chr(64)+chr(0))
        ser.close()
        logfile.close()
        thread.stop(get_values, ())
    except:
        pass
    main.destroy()



# ----- GUI-Elemente ---------------

main = Tk()

#frame1
frame1 = (Frame(main))
frame1.pack()
text1 = Label(frame1, text="Steuerprogramm fuer AD210", font="bold")
text1.pack(anchor="w")


#frame2, Schieberegler
frame2 = (Frame(main))
frame2.pack(anchor="w")
label2 = Label(frame2, text="PWM ")
label2.pack(side="left", padx=10, pady=16)
text2 = Text(frame2, bg="orange", width=6, height=1, font=(12))
text2.pack(side="left", pady=10)
scale = Scale( frame2, orient="horizontal", 
        length=256,resolution=1, to=255)   # Laenge Slider auf Bildschirm, Aufloesung, Endwert
scale.pack(side="right", padx=10)


#frame3 , ADC1
frame3 = (Frame(main))
frame3.pack(anchor="w")
label3 = Label(frame3, text="ADC1")
label3.pack(side="left",padx=10)
lb_adc1 = Text(frame3, bg="orange", width=6, height=1, font=(12))
lb_adc1.pack(side="left")
# Auswahlknoepfe Messbereich ADC1
ref1 = StringVar()
ref1.set("lo")
rb3 =Radiobutton(frame3, text="10V", variable=ref1, value= "lo")
rb3.pack(side="left", padx = 10)
rb3 =Radiobutton(frame3, text="30V", variable=ref1, value= "hi")
rb3.pack(side="left")


#frame4 , ADC 2
frame4 = (Frame(main))
frame4.pack(anchor="w")
label4 = Label(frame4, text="ADC2")
label4.pack(side="left", padx=10)
lb_adc2 = Text(frame4, bg="orange", width=6, height=1, font=(12))
lb_adc2.pack(side="left", pady = 10)
# Auswahlknoepfe Messbereich ADC2
ref2 = StringVar()
ref2.set("lo")
rb4 =Radiobutton(frame4, text="10V", variable=ref2, value= "lo")
rb4.pack(side="left",padx = 10)
rb4 =Radiobutton(frame4, text="30V", variable=ref2, value= "hi")
rb4.pack(side="left")


#frame5, Eingabe Intervall
frame5 = (Frame(main))
frame5.pack(anchor = "w")
entry5 = Entry(frame5, width=5,bg="white")
entry5.pack(side="left", padx = 10)
text5 = Label(frame5, text="Intervall der Logfile-Eintraege (in s)   ")
text5.pack(side="left")


#frame6, Eingabe Logfile-Name 
frame6 = (Frame(main))
frame6.pack(anchor="w")
entry6 = Entry(frame6, width=16,bg="white")
entry6.pack(side="left", padx = 10)
text6 = Label(frame6, text = "Name des Logfiles ")
text6.pack(side="left", pady=10)


#frame7, Start/Stop Log
frame7 = (Frame(main))
frame7.pack(anchor="w")
widget_start = Button(frame7, text="Start Log",command=start_log)
widget_start.pack(side="left", padx = 10)
widget_stop = Button(frame7, text="Stop Log",command=stop_log)
widget_stop.pack(side="left")


#frame8, Quit-Button
text8 = Label(main, text= "")
text8.pack(side="left", padx = 10, pady = 10)
button1 = Button(main, text="Quit",command=ende)
button1.pack(side="right", padx = 10)



# ----- Main Loop---------------

thread.start_new_thread(get_values, ()) # thread fuer Abfrage der seriellen Schnitttstelle 
main.mainloop()                         # ruft GUI auf
